
#include <stdio.h>
void png_64bit_product (long v1, long v2, unsigned long *hi_product,
   unsigned long *lo_product)
{
 int a, b, c, d;
 long lo, hi, x, y;

 a = (v1 >> 16) & 0xffff;
 b = v1 & 0xffff;
 c = (v2 >> 16) & 0xffff;
 d = v2 & 0xffff;

 lo = b * d;                   /* BD */
 x = a * d + c * b;            /* AD + CB */
 y = ((lo >> 16) & 0xffff) + x;

 lo = (lo & 0xffff) | ((y & 0xffff) << 16);
 hi = (y >> 16) & 0xffff;

 hi += a * c;                  /* AC */

 *hi_product = (unsigned long)hi;
 *lo_product = (unsigned long)lo;
}
main()
{
    unsigned long hi,lo;
    png_64bit_product(2,2,&hi,&lo);
    printf("2x2=%4a%4a\n",hi,lo);
    png_64bit_product(-2,-2,&hi,&lo);
    printf("-2x-2=%4a%4a\n",hi,lo);
    png_64bit_product(-2,2,&hi,&lo);
    printf("-2x2=%4a%4a\n",hi,lo);
    png_64bit_product(2,-2,&hi,&lo);
    printf("2x-2=%4a%4a\n",hi,lo);

    png_64bit_product(10000,10000,&hi,&lo);
    printf("10000x10000=%4a%4a\n",hi,lo);
    png_64bit_product(-10000,-10000,&hi,&lo);
    printf("-10000x-10000=%4a%4a\n",hi,lo);
    png_64bit_product(-10000,10000,&hi,&lo);
    printf("-10000x10000=%4a%4a\n",hi,lo);
    png_64bit_product(10000,-10000,&hi,&lo);
    printf("10000x-10000=%4a%4a\n",hi,lo);
}
